package src.rsa;

import java.math.BigInteger;

public class RSAEncryptor {

    public static BigInteger encrypt(BigInteger message, BigInteger[] publicKey) {
        BigInteger N = publicKey[0];
        BigInteger e = publicKey[1];
        return message.modPow(e, N); // Effektiv modular exponentiation
    }    

    public static BigInteger decrypt(BigInteger ciphertext, BigInteger[] privateKey) {
        BigInteger N = privateKey[0];
        BigInteger d = privateKey[1];
        return ciphertext.modPow(d, N); // Effektiv modular exponentiation
    }    

    public static void main(String[] args) {
        System.out.println("=== Test av RSA Kryptering/Dekryptering ===");
    
        // 1️⃣ Generera RSA-nycklar
        RSAKeyGenerator rsa = new RSAKeyGenerator(512);
        BigInteger[] publicKey = rsa.getPublicKey();
        BigInteger[] privateKey = rsa.getPrivateKey();
    
        // 2️⃣ Slumpmässigt meddelande att kryptera
        BigInteger message = new BigInteger("123456789");
        System.out.println("Original meddelande: " + message);
    
        // 3️⃣ Kryptera meddelandet
        BigInteger ciphertext = encrypt(message, publicKey);
        System.out.println("Krypterat meddelande: " + ciphertext);
    
        // 4️⃣ Dekryptera meddelandet
        BigInteger decrypted = decrypt(ciphertext, privateKey);
        System.out.println("Dekrypterat meddelande: " + decrypted);
    
        // 5️⃣ Verifiera att dekrypteringen är korrekt
        System.out.println("Stämmer dekrypteringen? " + message.equals(decrypted));
    }
    
}